<?php

namespace App\Policies;

use Illuminate\Auth\Access\Response;
use App\Models\GrMaster;
use App\Models\User;

class GrMasterPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->checkPermissionTo('view-any GrMaster');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, GrMaster $grmaster): bool
    {
        return $user->checkPermissionTo('view GrMaster');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->checkPermissionTo('create GrMaster');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, GrMaster $grmaster): bool
    {
        return $user->checkPermissionTo('update GrMaster');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, GrMaster $grmaster): bool
    {
        return $user->checkPermissionTo('delete GrMaster');
    }

    /**
     * Determine whether the user can delete any models.
     */
    public function deleteAny(User $user): bool
    {
        return $user->checkPermissionTo('delete-any GrMaster');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, GrMaster $grmaster): bool
    {
        return $user->checkPermissionTo('restore GrMaster');
    }

    /**
     * Determine whether the user can restore any models.
     */
    public function restoreAny(User $user): bool
    {
        return $user->checkPermissionTo('restore-any GrMaster');
    }

    /**
     * Determine whether the user can replicate the model.
     */
    public function replicate(User $user, GrMaster $grmaster): bool
    {
        return $user->checkPermissionTo('replicate GrMaster');
    }

    /**
     * Determine whether the user can reorder the models.
     */
    public function reorder(User $user): bool
    {
        return $user->checkPermissionTo('reorder GrMaster');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, GrMaster $grmaster): bool
    {
        return $user->checkPermissionTo('force-delete GrMaster');
    }

    /**
     * Determine whether the user can permanently delete any models.
     */
    public function forceDeleteAny(User $user): bool
    {
        return $user->checkPermissionTo('force-delete-any GrMaster');
    }
}
